<?php
defined('_JEXEC') or die;

/**
 * Template for Joomla! CMS, created with Artisteer.
 * See readme.txt for more details on how to use the template.
 */

require_once dirname(__FILE__) . DIRECTORY_SEPARATOR . 'functions.php';

// Create alias for $this object reference:
$document = $this;

// Shortcut for template base url:
$templateUrl = $document->baseurl . '/templates/' . $document->template;

Artx::load("Artx_Page");

// Initialize $view:
$view = $this->artx = new ArtxPage($this);

// Decorate component with Artisteer style:
$view->componentWrapper();

JHtml::_('behavior.framework', true);

?>
<!DOCTYPE html>
<html dir="ltr" lang="<?php echo $document->language; ?>">
<head>
    <jdoc:include type="head" />
    <link rel="stylesheet" href="<?php echo $document->baseurl; ?>/templates/system/css/system.css" />
    <link rel="stylesheet" href="<?php echo $document->baseurl; ?>/templates/system/css/general.css" />

    <!-- Created by Artisteer v4.1.0.59861 -->
    
    
    <meta name="viewport" content="initial-scale = 1.0, maximum-scale = 1.0, user-scalable = no, width = device-width">

    <!--[if lt IE 9]><script src="https://html5shiv.googlecode.com/svn/trunk/html5.js"></script><![endif]-->
    <link rel="stylesheet" href="<?php echo $templateUrl; ?>/css/template.css" media="screen">
    <!--[if lte IE 7]><link rel="stylesheet" href="<?php echo $templateUrl; ?>/css/template.ie7.css" media="screen" /><![endif]-->
    <link rel="stylesheet" href="<?php echo $templateUrl; ?>/css/template.responsive.css" media="all">
<link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family=Allan&amp;subset=latin">

<link rel="shortcut icon" href="favicon.ico" type="image/x-icon">
    <script>if ('undefined' != typeof jQuery) document._artxJQueryBackup = jQuery;</script>
    <script src="<?php echo $templateUrl; ?>/jquery.js"></script>
    <script>jQuery.noConflict();</script>

    <script src="<?php echo $templateUrl; ?>/script.js"></script>
    <?php $view->includeInlineScripts() ?>
    <script>if (document._artxJQueryBackup) jQuery = document._artxJQueryBackup;</script>
    <script src="<?php echo $templateUrl; ?>/script.responsive.js"></script>
</head>
<body>

<div id="sjp-main">
    <div class="sjp-sheet clearfix">
<header class="sjp-header"><?php echo $view->position('position-30', 'sjp-nostyle'); ?>


    <div class="sjp-shapes">

            </div>
<h1 class="sjp-headline" data-left="3.04%">
    <a href="<?php echo $document->baseurl; ?>/"><?php echo $this->params->get('siteTitle'); ?></a>
</h1>
<h2 class="sjp-slogan" data-left="2.59%"><?php echo $this->params->get('siteSlogan'); ?></h2>

<div class="sjp-positioncontrol sjp-positioncontrol-1472969965" id="logo" data-left="1.81%">
<?php echo $view->position('position-31', 'sjp-nostyle'); ?></div>
<div class="sjp-positioncontrol sjp-positioncontrol-2011705880" id="social" data-left="98.08%">
<?php echo $view->position('position-32', 'sjp-nostyle'); ?></div>
<div class="sjp-positioncontrol sjp-positioncontrol-536601707" id="buscar" data-left="95.61%">
<?php echo $view->position('position-33', 'sjp-nostyle'); ?></div>



<?php if ($view->containsModules('position-1', 'position-28', 'position-29')) : ?>
<nav class="sjp-nav">
    
<?php if ($view->containsModules('position-28')) : ?>
<div class="sjp-hmenu-extra1"><?php echo $view->position('position-28'); ?></div>
<?php endif; ?>
<?php if ($view->containsModules('position-29')) : ?>
<div class="sjp-hmenu-extra2"><?php echo $view->position('position-29'); ?></div>
<?php endif; ?>
<?php echo $view->position('position-1'); ?>
 
    </nav>
<?php endif; ?>

                    
</header>
<?php echo $view->position('position-15', 'sjp-nostyle'); ?>
<?php echo $view->positions(array('position-16' => 33, 'position-17' => 33, 'position-18' => 34), 'sjp-block'); ?>
<div class="sjp-layout-wrapper">
                <div class="sjp-content-layout">
                    <div class="sjp-content-layout-row">
                        <?php if ($view->containsModules('position-7', 'position-4', 'position-5')) : ?>
<div class="sjp-layout-cell sjp-sidebar1">
<?php echo $view->position('position-7', 'sjp-block'); ?>
<?php echo $view->position('position-4', 'sjp-block'); ?>
<?php echo $view->position('position-5', 'sjp-block'); ?>



                        </div>
<?php endif; ?>

                        <div class="sjp-layout-cell sjp-content">
<?php
  echo $view->position('position-19', 'sjp-nostyle');
  if ($view->containsModules('position-2'))
    echo artxPost($view->position('position-2'));
  echo $view->positions(array('position-20' => 50, 'position-21' => 50), 'sjp-article');
  echo $view->position('position-12', 'sjp-nostyle');
  echo artxPost(array('content' => '<jdoc:include type="message" />', 'classes' => ' sjp-messages'));
  echo '<jdoc:include type="component" />';
  echo $view->position('position-22', 'sjp-nostyle');
  echo $view->positions(array('position-23' => 50, 'position-24' => 50), 'sjp-article');
  echo $view->position('position-25', 'sjp-nostyle');
?>



                        </div>
                        <?php if ($view->containsModules('position-6', 'position-8', 'position-3')) : ?>
<div class="sjp-layout-cell sjp-sidebar2">
<?php echo $view->position('position-6', 'sjp-block'); ?>
<?php echo $view->position('position-8', 'sjp-block'); ?>
<?php echo $view->position('position-3', 'sjp-block'); ?>


                        </div>
<?php endif; ?>
                    </div>
                </div>
            </div>
<?php echo $view->positions(array('position-9' => 33, 'position-10' => 33, 'position-11' => 34), 'sjp-block'); ?>
<?php echo $view->position('position-26', 'sjp-nostyle'); ?>


    </div>
<footer class="sjp-footer">
  <div class="sjp-footer-inner">
<?php if ($view->containsModules('position-27')) : ?>
    <?php echo $view->position('position-27', 'sjp-nostyle'); ?>
<?php else: ?>
<p style="text-align: center;"><span style="font-size: 10px;">Desarrollado por <a href="http://somosjoomla.com" target="_blank" style="font-size: 10px; " somos="" title="Somos Joomla">somosjoomla.com</a></span></p><p style="text-align: center;"><br></p>
  <?php endif; ?>
</div>
</footer>

</div>



<?php echo $view->position('debug'); ?>
</body>
</html>